// This file is generated by kconfig_compiler from ktikz.kcfg.
// All changes you do to this file will be lost.
#ifndef KTIKZ_SETTINGS_H
#define KTIKZ_SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <kglobalsettings.h>
namespace KtikZ {

class Settings : public KConfigSkeleton
{
  public:
    class EnumCustomize
    {
      public:
      enum type { Standard, Custom, COUNT };
    };

    static Settings *self();
    ~Settings();

    /**
      Set Whether the TikZ commands should be listed in a dock widget instead of in a menu.
    */
    static
    void setCommandsInDock( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "CommandsInDock" ) ))
        self()->mCommandsInDock = v;
    }

    /**
      Get Whether the TikZ commands should be listed in a dock widget instead of in a menu.
    */
    static
    bool commandsInDock()
    {
      return self()->mCommandsInDock;
    }

    /**
      Set Whether the preview is generated automatically while editing instead of only when pressing a button.
    */
    static
    void setBuildAutomatically( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "BuildAutomatically" ) ))
        self()->mBuildAutomatically = v;
    }

    /**
      Get Whether the preview is generated automatically while editing instead of only when pressing a button.
    */
    static
    bool buildAutomatically()
    {
      return self()->mBuildAutomatically;
    }

    /**
      Set Whether to reload the TikZ image each time that the file is modified by another program.
    */
    static
    void setWatchFile( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "WatchFile" ) ))
        self()->mWatchFile = v;
    }

    /**
      Get Whether to reload the TikZ image each time that the file is modified by another program.
    */
    static
    bool watchFile()
    {
      return self()->mWatchFile;
    }

    /**
      Set The path to the pdflatex command.
    */
    static
    void setLatexCommand( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "LatexCommand" ) ))
        self()->mLatexCommand = v;
    }

    /**
      Get The path to the pdflatex command.
    */
    static
    QString latexCommand()
    {
      return self()->mLatexCommand;
    }

    /**
      Set The path to the pdftops command.
    */
    static
    void setPdftopsCommand( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "PdftopsCommand" ) ))
        self()->mPdftopsCommand = v;
    }

    /**
      Get The path to the pdftops command.
    */
    static
    QString pdftopsCommand()
    {
      return self()->mPdftopsCommand;
    }

    /**
      Set The path to the TikZ documentation file.
    */
    static
    void setTikzDocumentation( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TikzDocumentation" ) ))
        self()->mTikzDocumentation = v;
    }

    /**
      Get The path to the TikZ documentation file.
    */
    static
    QString tikzDocumentation()
    {
      return self()->mTikzDocumentation;
    }

    /**
      Set Whether to run pdflatex with the --shell-escape option.
    */
    static
    void setUseShellEscaping( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "UseShellEscaping" ) ))
        self()->mUseShellEscaping = v;
    }

    /**
      Get Whether to run pdflatex with the --shell-escape option.
    */
    static
    bool useShellEscaping()
    {
      return self()->mUseShellEscaping;
    }

    /**
      Set The file name of the currently used template.
    */
    static
    void setTemplateFile( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TemplateFile" ) ))
        self()->mTemplateFile = v;
    }

    /**
      Get The file name of the currently used template.
    */
    static
    QString templateFile()
    {
      return self()->mTemplateFile;
    }

    /**
      Set The list of file names of the previously used templates.
    */
    static
    void setTemplateRecent( const QStringList & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TemplateRecent" ) ))
        self()->mTemplateRecent = v;
    }

    /**
      Get The list of file names of the previously used templates.
    */
    static
    QStringList templateRecent()
    {
      return self()->mTemplateRecent;
    }

    /**
      Set The text in the template file which is replaced by the TikZ code before typesetting.
    */
    static
    void setTemplateReplaceText( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TemplateReplaceText" ) ))
        self()->mTemplateReplaceText = v;
    }

    /**
      Get The text in the template file which is replaced by the TikZ code before typesetting.
    */
    static
    QString templateReplaceText()
    {
      return self()->mTemplateReplaceText;
    }

    /**
      Set The path to the editor command used for editing templates.
    */
    static
    void setTemplateEditor( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "TemplateEditor" ) ))
        self()->mTemplateEditor = v;
    }

    /**
      Get The path to the editor command used for editing templates.
    */
    static
    QString templateEditor()
    {
      return self()->mTemplateEditor;
    }

    /**
      Set The font of the main text in the editor.
    */
    static
    void setGeneralFont( const QFont & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "GeneralFont" ) ))
        self()->mGeneralFont = v;
    }

    /**
      Get The font of the main text in the editor.
    */
    static
    QFont generalFont()
    {
      return self()->mGeneralFont;
    }

    /**
      Set Whether to show white spaces.
    */
    static
    void setShowWhiteSpaces( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowWhiteSpaces" ) ))
        self()->mShowWhiteSpaces = v;
    }

    /**
      Get Whether to show white spaces.
    */
    static
    bool showWhiteSpaces()
    {
      return self()->mShowWhiteSpaces;
    }

    /**
      Set Whether to show tabulators.
    */
    static
    void setShowTabulators( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowTabulators" ) ))
        self()->mShowTabulators = v;
    }

    /**
      Get Whether to show tabulators.
    */
    static
    bool showTabulators()
    {
      return self()->mShowTabulators;
    }

    /**
      Set Whether to highlight matching brackets.
    */
    static
    void setShowMatchingBrackets( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowMatchingBrackets" ) ))
        self()->mShowMatchingBrackets = v;
    }

    /**
      Get Whether to highlight matching brackets.
    */
    static
    bool showMatchingBrackets()
    {
      return self()->mShowMatchingBrackets;
    }

    /**
      Set The color used to highlight white spaces.
    */
    static
    void setColorWhiteSpaces( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ColorWhiteSpaces" ) ))
        self()->mColorWhiteSpaces = v;
    }

    /**
      Get The color used to highlight white spaces.
    */
    static
    QColor colorWhiteSpaces()
    {
      return self()->mColorWhiteSpaces;
    }

    /**
      Set The color used to highlight tabulators.
    */
    static
    void setColorTabulators( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ColorTabulators" ) ))
        self()->mColorTabulators = v;
    }

    /**
      Get The color used to highlight tabulators.
    */
    static
    QColor colorTabulators()
    {
      return self()->mColorTabulators;
    }

    /**
      Set The color used to highlight matching brackets.
    */
    static
    void setColorMatchingBrackets( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ColorMatchingBrackets" ) ))
        self()->mColorMatchingBrackets = v;
    }

    /**
      Get The color used to highlight matching brackets.
    */
    static
    QColor colorMatchingBrackets()
    {
      return self()->mColorMatchingBrackets;
    }

    /**
      Set Whether to use TikZ code completion.
    */
    static
    void setUseCompletion( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "UseCompletion" ) ))
        self()->mUseCompletion = v;
    }

    /**
      Get Whether to use TikZ code completion.
    */
    static
    bool useCompletion()
    {
      return self()->mUseCompletion;
    }

    /**
      Set The type of syntax highlighting.
    */
    static
    void setCustomize( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "Customize" ) ))
        self()->mCustomize = v;
    }

    /**
      Get The type of syntax highlighting.
    */
    static
    int customize()
    {
      return self()->mCustomize;
    }

    /**
      Set The factor by which the preview is zoomed.
    */
    static
    void setZoomFactor( double v )
    {
      if (v < 0.1)
      {
        kDebug() << "setZoomFactor: value " << v << " is less than the minimum value of 0.1";
        v = 0.1;
      }

      if (v > 6.0)
      {
        kDebug() << "setZoomFactor: value " << v << " is greater than the maximum value of 6.0";
        v = 6.0;
      }

      if (!self()->isImmutable( QString::fromLatin1( "ZoomFactor" ) ))
        self()->mZoomFactor = v;
    }

    /**
      Get The factor by which the preview is zoomed.
    */
    static
    double zoomFactor()
    {
      return self()->mZoomFactor;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // General Options
    bool mCommandsInDock;
    bool mBuildAutomatically;
    bool mWatchFile;
    QString mLatexCommand;
    QString mPdftopsCommand;
    QString mTikzDocumentation;
    bool mUseShellEscaping;
    QString mTemplateFile;
    QStringList mTemplateRecent;
    QString mTemplateReplaceText;
    QString mTemplateEditor;

    // Editor
    QFont mGeneralFont;
    bool mShowWhiteSpaces;
    bool mShowTabulators;
    bool mShowMatchingBrackets;
    QColor mColorWhiteSpaces;
    QColor mColorTabulators;
    QColor mColorMatchingBrackets;
    bool mUseCompletion;

    // Highlighting
    int mCustomize;

    // Preview
    double mZoomFactor;

  private:
};

}

#endif

